<script type="text/html" data-help-name="dim-xml-state-client">
  <p>
    A DIM-XML Client node to subscribe a State service on a DIM Service
    Provider (DIS). This node is used to get the current state of state machine.
  </p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object</span></dt>
    <dd>The service value received.</dd>
    <dt class="optional">
      timestamp<span class="property-type">number</span>
    </dt>
    <dd>The value's UNIX timestamp in millisecs.</dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node must be configured with the name of the service to be subscribed
    to and a connection to the the DIM Name Server (DNS) hosting that service.
    For the latter, it is possible to either create a new DNS Server connection
    by clicking on the pencil icon or use an existing one shared between
    several DIM-XML nodes.
  </p>
  <p>
    The node can retrieve the list of the <i>State</i> services registered on
    the DNS Server set-up.
  </p>
  <p>
    The received service value is saved in the output <code>payload</code>
    property and has the following attributes:
    <ul>
      <li>
        <code>value</code>, an integer which describes the currently active
        code state. Negative numbers are reserved for built-in states, in
        particular the values <b>-1</b> and <b>-2</b> are reserved for the
        states "NOT READY" and "ERROR" rispectively;
      </li>
      <li>
        <code>strValue</code>, a string that describes the currently active
        state;
      </li>
      <li>
        <code>errors</code>, the list of active errors. If at least one error
        is active, <i>value</i> is <b>-2</b> and <i>strValue</i> is equal to
        <b>ERROR</b>;
      </li>
      <li>
        <code>warnings</code>, the list of active warnings;
      </li>
      <li>
        <code>description</code>, the list of all possible states, each with
        its own <b>value</b> and <b>strValue</b>.
      </li>
    </ul>
    Errors and warnings contain a <b>code</b> which identifies them and a
    <b>message</b> to give details.
  </p>
  <p>
    By default, the node is configured to retrieve the service value manually,
    by clicking on its button within the editor. It can also be set to monitor
    a value, get the value with a given schedule or both. In particular, with
    the option:
    <ul>
      <li><b>Monitored</b>, if enabled, the node receives a service value when
        updated server side.
      <li><b>Scheduled</b>, if enabled, the node receives a service value at a
        regular time intervals defined by the <i>Every</i> field. The time
        interval is equal to 1000 millisecs by default.
    </ul>
  </p>
  <p>
    The first service value is received upon subscription, which is the current
    service value or a <i>null</i> one if it is not set.
  </p>
  <p>
    It is also possible to request service values with additional timestamp
    information by selecting the <b>Stamped</b> option. Thus, the value's
    timestamp is saved in the <code>msg.timestamp</code> property.
  </p>
</script>
